#include <stdio.h>	/* standard C i/o facilities */
#include <unistd.h>	/* Unix System Calls */
#include <sys/types.h>	/* system data type definitions */
#include <sys/socket.h> /* socket specific definitions */
#include <netinet/in.h> /* INET constants and stuff */
#include <arpa/inet.h>	/* IP address conversion stuff */
#include <stdlib.h>	/* malloc */
#include <pthread.h>	/* Posix Threads stuff */
#include <unistd.h>	/* gethostname */

#include <netdb.h>


// For MySQL
#include <mysql.h>
#include "common.h"

#define TRUE	1
#define FALSE	0

//#define SERVER_PORT	1500
int SERVER_PORT =1500;

// For MySQL
//#define def_db_host "127.0.0.1"
//#define def_db_user "root"
//#define def_db_name "deneme"
//#define def_db_pass "c4corp"
//#define def_db_port 3306
#define def_unix_socket NULL

#define Ack		"000"
#define LogData		"001"
#define DBUpReq		"010"
#define WrDoorIDNot	"011"

#define ReTiMonReq	"100"
#define LogDataReq	"101"
#define RelDoDBData	"110"
#define AllDoDBData	"111"
#define Sync		"111"
#define zeros		"0000000000"

// Logss Table
#define fldLOGLog_No			0
#define fldLOGDoor_No			1
#define fldLOGReader_No			2
#define fldLOGMessage_No		3
#define fldLOGDateTime			4
#define fldLOGCard_Number		5

// Doors Table
#define fldDOODoor_No			0
#define fldDOODoor_Name			1
#define fldDOORoom_No			2
#define fldDOODoor_Address		3
#define fldDOOEvent_Capacity		4
#define fldDOOThreshold_Capacity	5
#define fldDOOTwo_Readers_Present	6
#define fldDOODoor_Type			7
#define fldDOOInner_Reader_Active	8
#define fldDOOOuter_Reader_Active	9
#define fldDOOStay_Open_Duration	10
#define fldDOODoor_Locked		11
#define fldDOODoor_Forced_Sensor	12
#define fldDOOOnline_Log		13

#define fldDOOIP_Adress			16

// Cards Table
#define fldCARCard_Number		0
#define fldCARInternal_Number		1
#define fldCARSurname			2
#define fldCARFirst_Name		3
#define fldCARMiddle_Name		4
#define fldCARAttendance_Follow		5
#define fldCAREnterance_Group		6
#define fldCARDepartment		7
#define fldCAREnabled			8
#define fldCARTelephone_Number		9
#define fldCARRegister_DateTime		10
#define fldCARExpire_DateTime		11

// Calendar Table
#define fldCALCalendar_No		0
#define fldCALDescription		1
#define fldCALDay			2
#define fldCALOpen_Time			3
#define fldCALAction_No			4
#define fldCALType			5
#define fldCALAction_Date		6

#define MAX_MSG 255

#define BUFSIZE 100
#define MAXCLIENTS 100

/*==========================================================*/
/* Global variables used by all the threads.
   clients is a list of flags, a 1 means the client is
   active (0 means available).

   client_sd is a list of socket descriptors, the only valid
   socket descriptors correspond to clients that are active
   (client_sd[i] is meaningless unless clients[i] is a 1).
*/

int clients[MAXCLIENTS]; 		/* Array of flags 1 means connected*/
//char door_ip[MAXCLIENTS][MAX_MSG];
//int client_sd[MAXCLIENTS]; 		/* array of socket descriptors */

int pport;				/* Passive mode port number */

char packet[BUFSIZE], def_db_host[BUFSIZE], def_db_user[BUFSIZE], def_db_name[BUFSIZE], def_db_pass[BUFSIZE];
int def_db_port;
/* mutex used to restrict access to clients and client_sd to a single
   thread at a time
*/

pthread_mutex_t mtx = PTHREAD_MUTEX_INITIALIZER;

/* functions to grab and release the mutex
   If anything goes wrong the server is shut down
   (somewhat rudely)
*/

void grablock() {
  /* grab the lock */
  if (pthread_mutex_lock(&mtx)!=0) {
    printf("error getting mutex lock\n");
    exit(1);
  }
}

void releaselock() {
  /* release the lock */
  if (pthread_mutex_unlock(&mtx)!=0) {
    printf("error releasing mutex lock\n");
    exit(1);
  }
}

/* a clientstruct is passed to each thread,
   to let it know which client it should handle
*/

typedef struct {
  struct sockaddr_in from;
  int sd;
} clientstruct, *clientptr;

int PacketData(int did, const char * code, int datalen, char * data) {
   char str[255], strtmp[255];
   int len=0;
   len= sprintf(strtmp, "%d", did);
   strncpy(str, zeros, (10 - len));
   str[10-len]='\0';

   strcat(str, strtmp);
   strcat(str, code);
   strcat(str, data);

   strcpy(packet, str);
   return(strlen(str));
}

// For MySQL
void process_door(MYSQL * mysql, MYSQL_RES * res_set, int sd, char * DoorID_Str)
{
	unsigned int f;
	MYSQL_ROW row;
//Door Data Paketleme//////////////////////////////////////////////////////////////////////////////
	int DoorID= 0;
	char str[255], strtmp[255];
	int len=0, n, i;
//	char DoorID_Str[11], msg_type[4], event[9], threshold[9],two[2], inner[2], outer[2],stay[9],lock[2],sensor[2],calendar[9],online[2];
	char msg_type[4], event[9], threshold[9],two[2], inner[2], outer[2],stay[9],lock[2],sensor[2],calendar[9],online[2];
//////////////////////////////////////////////////////////////////////////////////////////////////
	while((row=mysql_fetch_row(res_set))!=NULL)
	{
//Door Data Paketleme/////////////////////////////////////////////////////////////////////////////
	strcpy(str, "");
	len=strlen(row[fldDOOEvent_Capacity]);
	strncpy(strtmp, zeros, (8 - len));
	strtmp[8-len]='\0';
	strcat(str, strtmp);
	strcat(str, row[fldDOOEvent_Capacity]);

	len=strlen(row[fldDOOThreshold_Capacity]);
	strncpy(strtmp, zeros, (8 - len));
	strtmp[8-len]='\0';
	strcat(str, strtmp);
	strcat(str, row[fldDOOThreshold_Capacity]);

	strcpy(strtmp, row[fldDOOTwo_Readers_Present]);
	strtmp[1]='\0';
	strcat(str, strtmp);

	strcpy(strtmp, row[fldDOOInner_Reader_Active]);
	strtmp[1]='\0';
	strcat(str, strtmp);

	strcpy(strtmp, row[fldDOOOuter_Reader_Active]);
	strtmp[1]='\0';
	strcat(str, strtmp);

	len=strlen(row[fldDOOStay_Open_Duration]);
	strncpy(strtmp, zeros, (8 - len));
	strtmp[8-len]='\0';
	strcat(str, strtmp);
	strcat(str, row[fldDOOStay_Open_Duration]);

	strcpy(strtmp, row[fldDOODoor_Locked]);
	strtmp[1]='\0';
	strcat(str, strtmp);

	strcpy(strtmp, row[fldDOODoor_Forced_Sensor]);
	strtmp[1]='\0';
	strcat(str, strtmp);

//	len=strlen(row[fldDOOUsed_Calendar]);
len=0;
	strncpy(strtmp, zeros, (8 - len));
	strtmp[8-len]='\0';
	strcat(str, strtmp);
//	strcat(str, row[fldDOOUsed_Calendar]);

	strcpy(strtmp, row[fldDOOOnline_Log]);
	strtmp[1]='\0';
	strcat(str, strtmp);

	len= PacketData(atoi(row[fldDOODoor_No]), RelDoDBData, 23, str);
	printf("packet:%s, length:%d \n", packet, len);  //MainBoarddan Servere gnderilecek 'packet'
//Door Data Paketleme Sonu////////////////////////////////////////////////////////////////////////
	n = write(sd,packet,len);
	if (n<0) printf("Error writing to client %d\n",i);
	}
	if (mysql_errno(mysql)==0)
	{
		fprintf(stdout,"Number of rows returned: %lu. \n", (unsigned long) mysql_num_rows(res_set));

	}
	else
	{
		fprintf(stderr,"mysql_fetch_row() failed \n");
	}
	n = write(sd,"quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0\0",51);
	if (n<0)
		printf("ERROR:writing to client.\n");
	else
		printf("Data has been sent:quit\n");
}

// For Cards
void process_card(MYSQL * mysql, MYSQL_RES * res_set, int sd, char * DoorID_Str)
{
	unsigned int f;
	MYSQL_ROW row;
//Card Data Paketleme//////////////////////////////////////////////////////////////////////////////
//	int DoorID= 8654000;
	char str[255], strtmp[255];
	int len=0, n, i;
//	char DoorID_Str[11], msg_type[4], Card_Number_Str[9], Int_Number[9], Attendance[2], date[17];
	char msg_type[4], Card_Number_Str[9], Int_Number[9], Attendance[2], date[17];
//////////////////////////////////////////////////////////////////////////////////////////////////
	while((row=mysql_fetch_row(res_set))!=NULL)
	{
//Card Data Paketleme/////////////////////////////////////////////////////////////////////////////
	strcpy(str, "");

	len=strlen(row[fldCARCard_Number]);
	strncpy(strtmp, zeros, (8 - len));
	strtmp[8-len]='\0';
	strcat(str, strtmp);
	strcat(str, row[fldCARCard_Number]);

	len=strlen(row[fldCARInternal_Number]);
	strncpy(strtmp, zeros, (8 - len));
	strtmp[8-len]='\0';
	strcat(str, strtmp);
	strcat(str, row[fldCARInternal_Number]);

	strcpy(strtmp, row[fldCARAttendance_Follow]);
	strtmp[1]='\0';
	strcat(str, strtmp);

	strcpy(strtmp, row[fldCARExpire_DateTime]);

	strncpy(date, strtmp+8, 2);
	date[2]='\0';
	strcat(str,date);

	strncpy(date, strtmp+5, 2);
	date[2]='\0';
	strcat(str,date);

	strncpy(date, strtmp, 4);
	date[4]='\0';
	strcat(str,date);

	strncpy(date, strtmp+11, 2);
	date[2]='\0';
	strcat(str,date);

	strncpy(date, strtmp+14, 2);
	date[2]='\0';
	strcat(str,date);

	strcat(str,"         ");

	len= PacketData(atoi(DoorID_Str), RelDoDBData, 23, str);
	printf("packet:%s, length:%d \n", packet, len);  //MainBoarddan Servere gnderilecek 'packet'
//Card Data Paketleme Sonu////////////////////////////////////////////////////////////////////////
	n = write(sd,packet,len);
	if (n<0) printf("Error writing to client %d\n",i);
	if (mysql_errno(mysql)==0)
	{
		fprintf(stdout,"Number of rows returned: %lu. \n", (unsigned long) mysql_num_rows(res_set));

	}
	else
	{
		fprintf(stderr,"mysql_fetch_row() failed \n");
	}
	}
	n = write(sd,"quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0\0",51);
	if (n<0)
		printf("Error writing to client %d\n");
	else
		printf("Data has been sent:quit\n");
}

// For Calendar
void process_calendar(MYSQL * mysql, MYSQL_RES * res_set, int sd, char * DoorID_Str)
{
	unsigned int f;
	MYSQL_ROW row;
//Calendar Data Paketleme//////////////////////////////////////////////////////////////////////////////
//	int DoorID= 8654000;
	char str[255], strtmp[255];
	int len=0, n, i;
//	char DoorID_Str[11], msg_type[4], Time[6], Calendar_No_Str[9], Action_No_Str[9], Day[2], Type[2], date[11];
	char msg_type[4], Time[6], Calendar_No_Str[9], Action_No_Str[9], Day[2], Type[2], date[11];
//////////////////////////////////////////////////////////////////////////////////////////////////
	while((row=mysql_fetch_row(res_set))!=NULL)
	{
//Calendar Data Paketleme/////////////////////////////////////////////////////////////////////////////
	strcpy(str, "");

	len=strlen(row[fldCALCalendar_No]);
	strncpy(strtmp, zeros, (8 - len));
	strtmp[8-len]='\0';
	strcat(str, strtmp);
	strcat(str, row[fldCALCalendar_No]);

	strcpy(strtmp, row[fldCALDay]);
	strtmp[1]='\0';
	strcat(str, strtmp);

	strcpy(strtmp, row[fldCALOpen_Time]);

	strncpy(date, strtmp, 2);
	date[2]='\0';
	strcat(str,date);

	strncpy(date, strtmp+3, 2);
	date[2]='\0';
	strcat(str,date);

	len=strlen(row[fldCALAction_No]);
	strncpy(strtmp, zeros, (8 - len));
	strtmp[8-len]='\0';
	strcat(str, strtmp);
	strcat(str, row[fldCALAction_No]);

	strcpy(strtmp, row[fldCALType]);
	strtmp[1]='\0';
	strcat(str, strtmp);

	strcpy(strtmp, row[fldCALAction_Date]);

	strncpy(date, strtmp+8, 2);
	date[2]='\0';
	strcat(str,date);

	strncpy(date, strtmp+5, 2);
	date[2]='\0';
	strcat(str,date);

	strncpy(date, strtmp, 4);
	date[4]='\0';
	strcat(str,date);

	strcat(str,"        ");

	len= PacketData(atoi(DoorID_Str), RelDoDBData, 23, str);
	printf("packet:%s, length:%d \n", packet, len);  //MainBoarddan Servere gnderilecek 'packet'
//Calendar Data Paketleme Sonu////////////////////////////////////////////////////////////////////////
	n = write(sd,packet,len);
	if (n<0) printf("Error writing to client %d\n",i);
	if (mysql_errno(mysql)==0)
	{
		fprintf(stdout,"Number of rows returned: %lu. \n", (unsigned long) mysql_num_rows(res_set));
	}
	else
	{
		fprintf(stderr,"mysql_fetch_row() failed \n");
	}
	}
	n = write(sd,"quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0\0",51);
	if (n<0)
		printf("Error writing to client %d\n");
	else
		printf("Data has been sent:quit\n");
}

void update_door(char *DoorID_Str, int sd) {
	char strtmp[255];
	struct tm *ptr;
	time_t tm;
	int n;
// For MySQL
	char line[MAX_MSG];
	MYSQL * mysql;
	MYSQL_RES *res_set;
	char quer[555],id[10];

	mysql = db_connect (
		def_db_host,
		def_db_user,
		def_db_pass,
		def_db_name,
		def_db_port,
		def_unix_socket,
		0);
	if(mysql== NULL)
		printf("Error: unable to connect to MySQL\n");
	else
	{
		printf("Connected to MySQL.\n");

	tm = time(NULL);
	ptr = localtime(&tm);
	strftime(strtmp ,100 , "%Y-%m-%d %H:%M:%S",ptr);
	strcpy(quer,"UPDATE tblDoors SET fldDOOUpdate_Time_Stamp='");
	strcat(quer,strtmp);
	strcat(quer,"' WHERE fldDOODoor_No='");
	strcat(quer,DoorID_Str);
	strcat(quer,"'");
			printf("Time Stamp Update%s.\n",quer);

		if(mysql_query(mysql,quer)==0)
			printf("Query succeeded.\n");
		else
			fprintf(stderr,"ERROR:Update Door Query failed: %s \n",mysql_error(mysql));
		strcpy(quer,"SELECT * FROM tblDoors WHERE fldDOODoor_No='");
		strcat(quer,DoorID_Str);
		strcat(quer,"'");
		printf("\n%s\n", quer);
		if(mysql_query(mysql,quer)==0)
		{
			printf("Query succeeded. About to fetch result. \n");
			res_set=mysql_store_result(mysql);
			if(res_set!=NULL)
			{
				process_door(mysql,res_set, sd, DoorID_Str);
				mysql_free_result(res_set);
			}
			else
			{
				if(mysql_field_count(mysql)>0)
					fprintf(stderr, "No result set. mysql_store_result() failed. %s \n",mysql_error(mysql));
				else
					printf("Querry was not meant to return data. \n");
				n = write(sd,"quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0\0",51);
				if (n<0)
					printf("Error writing to client %d\n");
				else
					printf("Data has been sent:quit\n");
			}
		}
		else
			fprintf(stderr,"ERROR:Update Door Query failed: %s \n",mysql_error(mysql));

//		strcpy(quer,"SELECT c.* FROM tblCards c, tblGroup_Permissions p, tblDoors d WHERE c.fldCAREntrance_Group=p.fldGROEntrance_No AND p.fldGRORoom_No=d.fldDOORoom_No AND d.fldDOODoor_No='");
//		strcat(quer,DoorID_Str);
//		strcat(quer,"' AND fldCAREnabled = 1");
		strcpy(quer,"SELECT c.* FROM tblCards c, tblGroup_Permissions p, tblDoors d WHERE c.fldCAREntrance_Group=p.fldGROEntrance_No AND p.fldGRORoom_No=d.fldDOORoom_No AND d.fldDOODoor_No='");
		strcat(quer,DoorID_Str);
		strcat(quer,"' AND fldCAREnabled = 1 AND (fldCARExpire_DateTime = '0000-00-00 00:00:00' OR fldCARExpire_DateTime > '");
//xxxx		strcat(quer,DoorID_Str);
		tm = time(NULL);
		ptr = localtime(&tm);
		strftime(strtmp ,100 , "%Y-%m-%d %H:%M:%S",ptr);
		strcat(quer,strtmp);
		strcat(quer,"' )");
		printf("\n%s\n", quer);
		if(mysql_query(mysql,quer)==0)
		{
			printf("Query succeeded. About to fetch result. \n");
			res_set=mysql_store_result(mysql);
			if(res_set!=NULL)
			{
				process_card(mysql,res_set, sd, DoorID_Str);
				mysql_free_result(res_set);
			}
			else
			{
				if(mysql_field_count(mysql)>0)
					fprintf(stderr, "No result set. mysql_store_result() failed. %s \n",mysql_error(mysql));
				else
					printf("Querry was not meant to return data. \n");
				n = write(sd,"quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0\0",51);
				if (n<0)
					printf("Error writing to client %d\n");
				else
					printf("Data has been sent:quit\n");
			}
		}
		else
			fprintf(stderr,"ERROR:Update Card Query failed: %s \n",mysql_error(mysql));

		strcpy(quer,"SELECT * FROM tblCalendars WHERE fldCALDoor_No='");
		strcat(quer,DoorID_Str);
		strcat(quer,"'");
		printf("\n%s\n", quer);
		if(mysql_query(mysql,quer)==0)
		{
			printf("Query succeeded. About to fetch result. \n");
			res_set=mysql_store_result(mysql);
			if(res_set!=NULL)
			{
				process_calendar(mysql,res_set, sd, DoorID_Str);
				mysql_free_result(res_set);
			}
			else
			{
				if(mysql_field_count(mysql)>0)
					fprintf(stderr, "No result set. mysql_store_result() failed. %s \n",mysql_error(mysql));
				else
					printf("Querry was not meant to return data. \n");
				n = write(sd,"quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0quit\0\0",51);
				if (n<0)
					printf("Error writing to client %d\n");
				else
					printf("Data has been sent:quit\n");
			}
		}
		else
			fprintf(stderr,"ERROR:Update Calendars Query failed: %s \n",mysql_error(mysql));
	}
	db_disconnect(mysql);
}

void write_log_data(char *str, char * DoorID_Str) {
  char Card_Number_Str[9], msg_type[4], reader[2], msg_no[3], date[17], strtmp[255];
  // For MySQL
	MYSQL * mysql;
	char line[MAX_MSG];
	MYSQL_RES *res_set;
	MYSQL_ROW row;
	
    grablock();
	mysql = db_connect (
	def_db_host,
	def_db_user,
	def_db_pass,
	def_db_name,
	def_db_port,
	def_unix_socket,
	0);

	if(mysql== NULL)
		printf("Error: unable to connect to MySQL\n");
	else
	{
		printf("Connected to MySQL.\n");

		strncpy(reader, str+13, 1);
		reader[1]='\0';
		printf("inner:%s\n",reader);

		strncpy(msg_no, str+14, 2);
		msg_no[2]='\0';
		printf("message:%s\n",msg_no);

		strcpy(date, "");

		strncpy(strtmp, str+20, 4);
		strtmp[4]='\0';
		strcat(date,strtmp);

		strcat(date,"-");

		strncpy(strtmp, str+18, 2);
		strtmp[2]='\0';
		strcat(date,strtmp);

		strcat(date,"-");

		strncpy(strtmp, str+16, 2);
		strtmp[2]='\0';
		strcat(date,strtmp);

		strcat(date," ");

		strncpy(strtmp, str+24, 2);
		strtmp[2]='\0';
		strcat(date,strtmp);

		strcat(date,":");

		strncpy(strtmp, str+26, 2);
		strtmp[2]='\0';
		strcat(date,strtmp);
		
		strcat(date,":");

		strncpy(strtmp, str+28, 2);
		strtmp[2]='\0';
		strcat(date,strtmp);

		printf("date:%s\n",date);

		strncpy(Card_Number_Str, str+30, 8);
		Card_Number_Str[8]='\0';
		printf("Card Number:%s\n",Card_Number_Str);

		strcpy(str, "SELECT * FROM tblLogs WHERE fldLOGDoor_No=");
		strcat(str,DoorID_Str);
		strcat(str, " AND fldLOGReader_No=");
		strcat(str,reader);
		strcat(str, " AND fldLOGMessage_No=");
		strcat(str,msg_no);
		strcat(str, " AND fldLOGDateTime='");
		strcat(str,date);
		strcat(str, "' AND fldLOGCard_Number=");
		strcat(str,Card_Number_Str);

		printf("QUERY:%s\n", str);

		if(mysql_query(mysql,str)==0) {
			printf("Query succeeded.\n");
			res_set=mysql_store_result(mysql);
			if(res_set!=NULL)
				if((row=mysql_fetch_row(res_set))==NULL)
				{
					strcpy(str, "INSERT INTO tblLogs (fldLOGDoor_No, fldLOGReader_No, fldLOGMessage_No, fldLOGDateTime, fldLOGCard_Number, fldLOGAcked) VALUES (");
					strcat(str,DoorID_Str);
					strcat(str,", ");
					strcat(str,reader);
					strcat(str,", ");
					strcat(str,msg_no);
					strcat(str,", '");
					strcat(str,date);
					strcat(str,"', ");
					strcat(str,Card_Number_Str);
					strcat(str,",1);");
					printf("QUERY:%s\n", str);
					if(mysql_query(mysql,str)==0)
						printf("Query succeeded.\n");
					else
						printf("ERROR:Query failed.2\n");
				} else
				{
					strcpy(str, "UPDATE tblLogs SET fldLOGAcked=1 WHERE fldLOGLog_No=");
					strcat(str,row[fldLOGLog_No]);
					printf("QUERY:%s\n", str);
					if(mysql_query(mysql,str)==0)
						printf("Query succeeded.\n");
					else
						printf("ERROR:Query failed.2\n");
				}
			}
		else
			printf("ERROR:Query failed.2\n");
	}
	db_disconnect(mysql);
    releaselock();
}

void *handle_client( void *arg) {
  clientptr me = (clientptr) arg;
  struct sockaddr_in from = me->from;
  int sd = me->sd;
  char buf[BUFSIZE], str[MAX_MSG], quer[MAX_MSG];
  int n;
  char Card_Number_Str[9], DoorID_Str[11], msg_type[4], reader[2], msg_no[3], date[17];
// For MySQL
	char line[MAX_MSG];
	MYSQL_RES *res_set;
	MYSQL * mysql;

  free(arg);

  /* DLH: By default a new thread is joinable, we don't
     really want this (unless we do something special we
     end up with the thread equivalent of zombies). So
     we explicitly change the thread type to detached
  */

  pthread_detach(pthread_self());

  printf("Thread %d started for client (sd %d)\n",
	 pthread_self(),sd);
  memset(buf,'\0', BUFSIZE-1);

  while ( (n=recv(sd,buf,51,0))>0) {
	strcpy(str, buf);	// buf'i str'ye at
	if (strcmp(buf, "quit")) {
		printf("\nGelen veri:%s\n\n",buf);
		strncpy(DoorID_Str, str, 10);
		DoorID_Str[10]= '\0';
		printf("Door ID:%s (IP:%s)\n", DoorID_Str, inet_ntoa(from.sin_addr));

		mysql = db_connect (
		def_db_host,
		def_db_user,
		def_db_pass,
		def_db_name,
		def_db_port,
		def_unix_socket,
		0);

		if(mysql== NULL)
			printf("Error: unable to connect to MySQL\n");
		else
		{
			printf("Connected to MySQL.\n");

			strcpy(quer,"UPDATE tblDoors SET fldDOOIP_Adress='");
			strcat(quer,inet_ntoa(from.sin_addr));
			strcat(quer,"' WHERE fldDOODoor_No='");
			strcat(quer,DoorID_Str);
			strcat(quer,"'");

			printf("QUERY:%s\n", quer);

			if(mysql_query(mysql,quer)==0)
				printf("Query succeeded. (Door IP has been updated...)\n");
			else
				printf("ERROR:Query failed. (Door IP has not been updated...)\n");
		}
		db_disconnect(mysql);
		strncpy(msg_type, str+10, 3);
		msg_type[3]= '\0';
		printf("Message Type:%s\n", msg_type);
		switch(atoi(msg_type)) {
		case 1:	// eger 001 log data ise
			write_log_data(str, DoorID_Str);
			break;
		case 10:
			printf("%s nolu kapiya database update gonder\n", DoorID_Str);
			update_door(DoorID_Str, sd);
			break;
		case 11:
			printf("%s nolu kapiya yanlis bilgi gonderildi!\n", DoorID_Str);
			break;
		}
	}
	else {
		strncpy(DoorID_Str, str, 10);
		DoorID_Str[10]= '\0';
		printf("Door ID:%s (IP:%s)\n", DoorID_Str, inet_ntoa(from.sin_addr));

		mysql = db_connect (
		def_db_host,
		def_db_user,
		def_db_pass,
		def_db_name,
		def_db_port,
		def_unix_socket,
		0);

		if(mysql== NULL)
			printf("Error: unable to connect to MySQL\n");
		else
		{
			printf("Connected to MySQL.\n");

			strcpy(quer,"UPDATE tblDoors SET fldDOOIP_Adress='");
			strcat(quer,inet_ntoa(from.sin_addr));
			strcat(quer,"' WHERE fldDOODoor_No='");
			strcat(quer,DoorID_Str);
			strcat(quer,"'");

			printf("QUERY:%s\n", quer);

			if(mysql_query(mysql,quer)==0)
				printf("Query succeeded. (Door IP has been updated...)\n");
			else
				printf("ERROR:Query failed. (Door IP has not been updated...)\n");
		}
		db_disconnect(mysql);

		printf("\nquit\n");
		close(sd);
		break;
	}
}

  return(NULL);
}

/* This supports a status interface on STDIN - the user running the
   server can find out the status of things by typing commands
   to the server. A separate thread handles this interaction.

   The argument to the thread is the socket descriptor
   of the passive server socket (we need this so we can
   find out and print out the server port number).
*/

char *statushelp = "Commands:\n"
"	?		this help\n"
"	status		show status\n";

void * server_status(void *arg) {
  char buff[100];
  char hostname[100] ;
  int n,i;


  /* get our hostname */
  gethostname(hostname,100);

  printf("Server Status Module XK-7413 operational...\n");

  while ((n=read(0,buff,100))>0) {
    switch(buff[0]) {
    case '?':
    case 'h':
    case 'H':
      printf(statushelp);	/* Help command */
      break;
    case 's':
    case 'S':
      printf("\n\n-------------OPSCON Server Status Report------------\n");

      printf("CHAT_OPS server up and running on %s, port %d\n",
	     hostname,pport);

      printf("MANDMS security status:\n");
      printf("\tCODEBLUE infiltration detection agent status: OK\n");
      printf("\tMSGPOK trace: enabled\n");
      printf("\tNIGHTTIME availability: unknown\n");
      printf("\tQWERTY: reverse-encoding (22 bits)\n");
      printf("\tCHOCCHIP module: missing and assumed digested\n\n");


      /* must get a lock before looking at the globals
	 (they might change in the middle of things). */

      grablock();
      n=0;
      for (i=0;i<MAXCLIENTS;i++) {
        if (clients[i])
	  n++;
      }

      printf("There are currently %d active clients (MAX is %d)\n",n,MAXCLIENTS);


      for (i=0;i<MAXCLIENTS;i++) {
	printf("Client[%d]  ",i);
	if (clients[i]) {
	  printf("Active\n");

	} else {
	  printf("empty\n");
	}
      }
      releaselock();

      break;
    }
  }
  return(NULL);
}


/* The message we send to new clients if we are full */
char *fullmsg = "Sorry - no vacancy\n";

/* The main sets up a passive socket and accepts new connections.  For
   each new connection:
       - if the server is full a message is sent to
         the client and the client connection is terminated.
       - otherwise a thread is started to handle the client
*/

int connect_to_door(int door_no) {
	int sd;
	int sockfd, port=1500;
	char strtmp[MAX_MSG];
	struct hostent *he;
	struct sockaddr_in their_addr; // connector's address information

// For MySQL
	MYSQL * mysql;
	char line[MAX_MSG];
	MYSQL_RES *res_set;
	MYSQL_ROW row;
	char quer[255],id[10];

	strcpy(quer,"SELECT * FROM tblDoors where fldDOODoor_No=");
	sprintf(strtmp, "%d",door_no);
	strcat(quer,strtmp);
	printf("\n%s\n", quer);
	mysql = db_connect (
		def_db_host,
		def_db_user,
		def_db_pass,
		def_db_name,
		def_db_port,
		def_unix_socket,
		0);
	if(mysql== NULL) {}
	else
	if(mysql_query(mysql,quer)==0)
					{
//			printf("Query succeeded. About to fetch result.\n");
						res_set=mysql_store_result(mysql);
						if(res_set!=NULL)
						{
							if((row=mysql_fetch_row(res_set))!=NULL) {
								if ((he=gethostbyname(row[fldDOOIP_Adress])) == NULL) {  // get the host info
									perror("gethostbyname");
//					exit(1);
								}
								else
								printf("REMOTE_IP:%s\n", row[fldDOOIP_Adress]);
				if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
					perror("socket");
//					exit(1);
				}

				their_addr.sin_family = AF_INET;    // host byte order
				their_addr.sin_port = htons(port);  // short, network byte order
				their_addr.sin_addr = *((struct in_addr *)he->h_addr);
				memset(&(their_addr.sin_zero), '\0', 8);  // zero the rest of the struct
				if (connect(sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) != -1)
				return sockfd;

}
}}
				return -1;
}

void * send_to_net(void *arg) {		// client in server hidden
printf("Connecting to door...\n");
	int sd;
	int sockfd, numbytes, valid=TRUE, think=0, debug_mode=FALSE, port=1500;
	char buf[MAX_MSG], str[MAX_MSG], strtmp[MAX_MSG], *strtmp2;
	struct hostent *he;
	struct sockaddr_in their_addr; // connector's address information
	char *hostname;
	int connected=TRUE, door_no, len, n, i;
	struct tm *ptr;
	time_t tm;

// For MySQL
	MYSQL * mysql, * mysql2;
	char line[MAX_MSG];
	MYSQL_RES *res_set;
	MYSQL_ROW row;
	char quer[255],id[10];

while(1) {
//log istegi
//real-time monitoring istegi
	mysql = db_connect (
		def_db_host,
		def_db_user,
		def_db_pass,
		def_db_name,
		def_db_port,
		def_unix_socket,
		0);
	if(mysql== NULL)
		printf("Error: unable to connect to MySQL\n");
	else
	{
//		printf("Connected to MySQL. \n");
		strcpy(quer,"SELECT * FROM tblDoors where fldDOOTime_Stamp>fldDOOUpdate_Time_Stamp");
//		printf("\n%s\n", quer);
		if(mysql_query(mysql,quer)==0)
		{
//			printf("Query succeeded. About to fetch result.\n");
			res_set=mysql_store_result(mysql);
			if(res_set!=NULL)
			{
				while((row=mysql_fetch_row(res_set))!=NULL) {
					if ((he=gethostbyname(row[fldDOOIP_Adress])) == NULL) {  // get the host info
						perror("gethostbyname");
					}
					else {
//						printf("REMOTE_IP:%s\n", row[fldDOOIP_Adress]);
						if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
							perror("socket");
						}
						else {
							their_addr.sin_family = AF_INET;    // host byte order
							their_addr.sin_port = htons(port);  // short, network byte order
							their_addr.sin_addr = *((struct in_addr *)he->h_addr);
							memset(&(their_addr.sin_zero), '\0', 8);  // zero the rest of the struct
							if (connect(sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) != -1) {
								update_door(row[fldDOODoor_No], sockfd);
							}
							close(sockfd);
						}
					}
				}
				mysql_free_result(res_set);
			}
			else
			{
				if(mysql_field_count(mysql)>0)
					fprintf(stderr, "No result set. mysql_store_res?lt() failed. %s \n",mysql_error(mysql));
				else
					printf("Query was not meant to return data.\n");
			}
		}
		else
			fprintf(stderr,"ERROR:Sent to net Query failed: %s \n",mysql_error(mysql));

		strcpy(quer,"SELECT * FROM tblLogs WHERE fldLOGAcked=1");
		if(mysql_query(mysql,quer)==0)
		{
			res_set=mysql_store_result(mysql);
			if(res_set!=NULL)
			{
				while((row=mysql_fetch_row(res_set))!=NULL) {
					door_no=atoi(row[fldLOGDoor_No]);
					printf("LOG:");
					sockfd=connect_to_door(door_no);
					if (sockfd!=-1) {
//Log Data Paketleme/////////////////////////////////////////////////////////////////////////////
						strcpy(str, "");
						strncpy(strtmp, row[fldLOGReader_No], 1);
						strtmp[1]='\0';
						strcat(str, strtmp);
						len=strlen(row[fldLOGMessage_No]);
						strncpy(strtmp, zeros, (2 - len));
						strtmp[2-len]='\0';
						strcat(str, strtmp);
						strcat(str, row[fldLOGMessage_No]);
						strtmp2=row[fldLOGDateTime];
						strncpy(strtmp, strtmp2+8, 2);
						strtmp[2]='\0';
						strcat(str, strtmp);
						strncpy(strtmp, strtmp2+5, 2);
						strtmp[2]='\0';
						strcat(str, strtmp);
						strncpy(strtmp, strtmp2, 4);
						strtmp[4]='\0';
						strcat(str, strtmp);
						strncpy(strtmp, strtmp2+11, 2);
						strtmp[2]='\0';
						strcat(str, strtmp);
						strncpy(strtmp, strtmp2+14, 2);
						strtmp[2]='\0';
						strcat(str, strtmp);
						strncpy(strtmp, strtmp2+17, 2);
						strtmp[2]='\0';
						strcat(str, strtmp);
						len=strlen(row[fldLOGCard_Number]);
						//printf("len:%d\n", len);
						strncpy(strtmp, zeros, (8 - len));
						strtmp[8-len]='\0';
						strcat(str, strtmp);
						strcat(str, row[fldLOGCard_Number]);
						strcat(str, "             ");
						//printf("sockfd:%d\n", sockfd);
						len= PacketData(door_no, Ack, 23, str);
						printf("LOG ACK:packet:%s, length:%d \n", packet, len);  //MainBoarddan Servere gnderilecek 'packet'
//Log Data Paketleme Sonu////////////////////////////////////////////////////////////////////////
						n = write(sockfd,packet,51);
if (atoi(row[fldLOGMessage_No])==0) {
//Log Data Paketleme/////////////////////////////////////////////////////////////////////////////
						strcpy(str, "   ");//xxxx
						tm = time(NULL);
						ptr = localtime(&tm);
						strftime(strtmp ,100 , "%d%m%Y%H%M%S",ptr);
						strcat(str,strtmp);
						strcat(str, "                     ");
						len= PacketData(door_no, Sync, 23, str);
						printf("packet:%s, length:%d \n", packet, len);  //MainBoarddan Servere gnderilecek 'packet'
//Log Data Paketleme Sonu////////////////////////////////////////////////////////////////////////
						n = write(sockfd,packet,51);
						if (n<0) printf("Error writing to client\n");
						mysql2 = db_connect (
							def_db_host,
							def_db_user,
							def_db_pass,
							def_db_name,
							def_db_port,
							def_unix_socket,
							0);
						if(mysql2== NULL)
							printf("Error: unable to connect to MySQL\n");
						else
						{
							tm = time(NULL);
							ptr = localtime(&tm);
							strftime(strtmp ,100 , "%Y/%m/%d %H:%M:%S",ptr);

							strcpy(str, "UPDATE tblDoors SET fldDOOTime_Stamp='");
							strcat(str,strtmp);
							strcat(str, "' WHERE fldDOODoor_No='");
							strcat(str, row[fldLOGDoor_No]);
							strcat(str, "'");
							//printf("QUERY:%s\n", str);
							if(mysql_query(mysql2,str)==0)
								printf("Query succeeded.\n");
							else
								printf("ERROR:Query failed.2\n");
						}
						db_disconnect(mysql2);
						sleep(1);
}
						n = write(sockfd,"quit                                               ",51);
						if (n<0) printf("Error writing to client\n");
						mysql2 = db_connect (
							def_db_host,
							def_db_user,
							def_db_pass,
							def_db_name,
							def_db_port,
							def_unix_socket,
							0);
						if(mysql2== NULL)
							printf("Error: unable to connect to MySQL\n");
						else
						{
							strcpy(str, "UPDATE tblLogs SET fldLOGAcked=0 WHERE fldLOGLog_No=");
							strcat(str,row[fldLOGLog_No]);
							//printf("QUERY:%s\n", str);
							if(mysql_query(mysql2,str)==0)
								printf("Query succeeded.\n");
							else
								printf("ERROR:Query failed.2\n");
						}
						db_disconnect(mysql2);
					}
					close(sockfd);
					sleep(1);
				}
				mysql_free_result(res_set);
			}
			else
			{
				if(mysql_field_count(mysql)>0)
					fprintf(stderr, "No result set. mysql_store_res?lt() failed. %s \n",mysql_error(mysql));
				else
					printf("Query was not meant to return data.\n");
			}
		}
		else
			fprintf(stderr,"ERROR:Sent to net Query failed: %s \n",mysql_error(mysql));
	}
	db_disconnect(mysql);
	sleep(2);
}
}

int main() {
  int ld,sd;
  struct sockaddr_in skaddr;
  struct sockaddr_in from;
  int addrlen,length;
  int i;
  clientptr newcli;
  pthread_t pt;
  FILE * consts_file;

//Reading constants
	consts_file=fopen("consts", "r");
	if (consts_file==NULL)
		printf("file error\n");
	fscanf(consts_file, "%s\n", &def_db_host);
//	printf("sql_host:%s\n", def_db_host);
	fscanf(consts_file, "%d\n", &def_db_port);
//	printf("def_db_port:%d\n", def_db_port);
	fscanf(consts_file, "%s\n", &def_db_name);
//	printf("def_db_name:%s\n", def_db_name);
	fscanf(consts_file, "%s\n", &def_db_user);
//	printf("def_db_user:%s\n", def_db_user);
	fscanf(consts_file, "%s\n", &def_db_pass);
//	printf("def_db_pass:%s\n", def_db_pass);
	fscanf(consts_file, "%d\n", &SERVER_PORT);
//	printf("SERVER_PORT:%d\n", SERVER_PORT);
	fclose(consts_file);

  if ((ld = socket( PF_INET, SOCK_STREAM, 0 )) < 0) {
    perror("Problem creating socket\n");
    exit(1);
  }

  skaddr.sin_family = AF_INET;
  skaddr.sin_addr.s_addr = htonl(INADDR_ANY);
  skaddr.sin_port = htons(SERVER_PORT);

  if (bind(ld, (struct sockaddr *) &skaddr, sizeof(skaddr))<0) {
    perror("Problem binding\n");
    exit(0);
  }

  /* find out what port we were assigned and print it out */
  length = sizeof( skaddr );
  if (getsockname(ld, (struct sockaddr *) &skaddr, &length)<0) {
    perror("Error getsockname\n");
    exit(1);
  }
  pport=ntohs(skaddr.sin_port);
  printf("port:%d\n",pport);

  /* put the socket into passive mode (waiting for connections) */
  if (listen(ld,5) < 0 ) {
    perror("Error calling listen\n");
    exit(1);
  }

  /* do some initialization (just to make sure) */
  for (i=0;i<MAXCLIENTS;i++)
    clients[i]=0;

  /* start up the server status module */
//  pthread_create(&pt,NULL,server_status,(void *)ld);
//  pthread_create(&pt,NULL,handle_db,(void *)ld);
//  pthread_create(&pt,NULL,listen_serial,(void *)ld);
//  pthread_create(&pt,NULL,send_to_serial,(void *)ld);
//  pthread_create(&pt,NULL,listen_net,(void *)ld);
  
	pthread_create(&pt,NULL,send_to_net,(void *)ld);

  /* now process incoming connections forever ... */

  while (1) {
    printf("Ready for a connection...\n");
    addrlen=sizeof(skaddr);
    if ( (sd = accept( ld, (struct sockaddr*) &from, &addrlen)) < 0) {
      perror("Problem with accept call\n");
      exit(1);
    }
    else
    printf("%s\n", inet_ntoa(from.sin_addr));

    printf("Got a connection - processing...\n");

    for (i=0;i<MAXCLIENTS;i++) {
      if (clients[i]==0) break;
    }

    if (i==MAXCLIENTS) {
      // TOO MANY CLIENTS
      write(sd,fullmsg,strlen(fullmsg));
      close(sd);
    } else {
      grablock();
      clients[i]=1;
      // release the lock
      releaselock();
      newcli = malloc(sizeof(clientstruct));
      newcli->from=from;
      newcli->sd=sd;

      /* Start up a thread for the client */
      /* DLH: The book says you can pass NULL as the first arg to
	 pthread_create, but when I do it (under Linux) I
	 get a SEGV. I don't really care what the thread ids are,
         but as long as I get it I print it out.*/

      pthread_create(&pt,NULL,handle_client,(void *) newcli);
      printf("New client connected: %u\n",pt);
    }
  }
}
